
CREATE_VARIABLE LINK_DEP_MAIN
select top 1 LINK from [{Variable_WorkDb}].dbo.DEPARTMENTS where NAME = ' '
GO

--  
UPDATE d SET d.ZB = {LINK_DEP_MAIN}
FROM 
	[{Variable_WorkDb}].dbo.DEPARTMENTS d
	inner join [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] do on do.LINK_NEW = d.LINK
GO

DECLARE @LINK_SRC INT 

---     
USE {Variable_WorkDb}

DECLARE @Cur1 CURSOR, @LINK INT
SET @Cur1 = CURSOR FORWARD_ONLY

FOR SELECT [LINK_NEW] FROM [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] 

OPEN @Cur1
FETCH NEXT FROM @Cur1 INTO @LINK
WHILE (@@fetch_status <> -1)
BEGIN
	IF (@@fetch_status <> -2)
	BEGIN

		SET @LINK_SRC = 
		(
		SELECT TOP 1 T.LINK_DEP
		FROM 
			dbo.DEPARTMENTS3 D
			INNER JOIN 
			(
				SELECT TOP 1 D.DEP_TYPE, D.ZB, SETTINGS.[LINK_DEP]
				FROM dbo.DEPARTMENTS3 D CROSS APPLY (SELECT R.[RECORD] AS LINK_DEP FROM dbo.GET_VAL_REFER('SMETA_N_CREATE_DEP', 'SMETA_NASTR_DEP_AU', NULL) R WHERE D.LINK = R.[RECORD]) SETTINGS
				WHERE D.DEP_TYPE = ''
				UNION ALL
				SELECT TOP 1 D.DEP_TYPE, D.ZB, SETTINGS.[LINK_DEP]
				FROM dbo.DEPARTMENTS3 D CROSS APPLY (SELECT R.[RECORD] AS LINK_DEP FROM dbo.GET_VAL_REFER('SMETA_N_CREATE_DEP', 'SMETA_NASTR_DEP_BU', NULL) R WHERE D.LINK = R.[RECORD]) SETTINGS
				WHERE D.DEP_TYPE = ''
				UNION ALL
				SELECT TOP 1 D.DEP_TYPE, D.ZB, SETTINGS.[LINK_DEP]
				FROM dbo.DEPARTMENTS3 D CROSS APPLY (SELECT R.[RECORD] AS LINK_DEP FROM dbo.GET_VAL_REFER('SMETA_N_CREATE_DEP', 'SMETA_NASTR_DEP_KU', NULL) R WHERE D.LINK = R.[RECORD]) SETTINGS
				WHERE D.DEP_TYPE = ''
			) T ON T.ZB = D.ZB AND T.DEP_TYPE = D.DEP_TYPE
		WHERE
			LINK = @LINK
		)

		IF @LINK_SRC IS NOT NULL
			EXEC [{Variable_WorkDb}].dbo.X_INIT_DEP @LINK_DEP_DST = @LINK, @MODE = 3, @LINK_DEP_SRC = @LINK_SRC
		ELSE
			EXEC [{Variable_WorkDb}].dbo.X_INIT_DEP @LINK_DEP_DST = @LINK, @MODE = 2, @PREV_LINK_ZB = {LINK_DEP_MAIN}


		--EXEC [{Variable_WorkDb}].dbo.X_INIT_DEP @LINK_DEP_DST = @LINK, @MODE = 2, @PREV_LINK_ZB = {LINK_DEP_MAIN}
		--EXEC [{Variable_WorkDb}].dbo.X_INIT_DEP @LINK_DEP_DST = @LINK, @MODE = 3, @LINK_DEP_SRC = {LINK_DEP_MAIN} --296173

	END

	FETCH NEXT FROM @Cur1 INTO @LINK
END

CLOSE @Cur1
DEALLOCATE @Cur1
GO

