SET XACT_ABORT ON
BEGIN TRAN

COMMIT TRAN
GO

SET XACT_ABORT ON
BEGIN TRAN

DECLARE @dDATE DATETIME
SET @dDATE = DATEADD(YEAR, DATEDIFF(YEAR, 0, GETDATE()), 0) --   

    ---   
DECLARE @MISSED_ACCOUNTS TABLE (cSource VARCHAR(10), cSinth VARCHAR(10), cAnalit VARCHAR(10), DEP_LINK_OLD INT, DEP_LINK_NEW INT)

INSERT INTO @MISSED_ACCOUNTS (cSource, cSinth, cAnalit, DEP_LINK_OLD, DEP_LINK_NEW)
SELECT sa.cSource, sa.cSinth, sa.cAnalit, dsks.LINK_OLD, dsks.LINK_NEW
FROM {Variable_SmetaDb}.dbo.S_ACCOUNTS sa
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_NASTR san ON san.SINTH = sa.cSinth AND san.ANALITH = sa.cAnalit
LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 ON sa2.LINK_DEP = {LINK_DEP_MAIN} AND sa2.CODE = CASE WHEN sa.ZABALANS = 1 AND ISNULL(sa.cSource,'') = '' THEN '0.' + sa.CODE ELSE sa.CODE END 
CROSS APPLY (SELECT DISTINCT ACCOUNT, DEP_LINK FROM {Variable_SmetaDb}.dbo.ARestTableByDate(@dDATE,DEFAULT) WHERE sa.LINK = ACCOUNT) rest
LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = rest.DEP_LINK
WHERE sa2.CODE IS NULL

INSERT INTO @MISSED_ACCOUNTS (cSource, cSinth, cAnalit, DEP_LINK_OLD, DEP_LINK_NEW)
SELECT sa.cSource, sa.cSinth, sa.cAnalit, dsks.LINK_OLD, dsks.LINK_NEW
FROM {Variable_SmetaDb}.dbo.S_ACCOUNTS sa
INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS_NASTR san ON san.SINTH = sa.cSinth AND san.ANALITH = sa.cAnalit
LEFT JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 ON sa2.LINK_DEP = {LINK_DEP_MAIN} AND sa2.CODE = CASE WHEN sa.ZABALANS = 1 AND ISNULL(sa.cSource,'') = '' THEN '0.' + sa.CODE ELSE sa.CODE END
CROSS APPLY  (SELECT DISTINCT gpa.ACCOUNT, G.DEP FROM {Variable_SmetaDb}.dbo.G_PROV g
                INNER JOIN {Variable_SmetaDb}.dbo.G_PROV1 g1 ON g1.LINK_UP = g.LINK
                INNER JOIN {Variable_SmetaDb}.dbo.G_PROV2 g2 ON g2.LINK_UP = g1.LINK
                INNER JOIN {Variable_SmetaDb}.dbo.G_PROV_AP gpa ON gpa.LINK_UP = g2.LINK
                WHERE g.[DATE] > @dDATE
                AND sa.LINK = gpa.ACCOUNT) prov
LEFT JOIN [{Variable_TempDb}].dbo.[__DEPARTMENTS_SMETA_KS] dsks ON dsks.LINK_OLD = prov.DEP
WHERE sa2.CODE IS NULL
AND NOT EXISTS (SELECT * FROM @MISSED_ACCOUNTS ma WHERE ma.cSource = sa.cSource AND ma.cSinth = sa.cSinth AND ma.cAnalit = sa.cAnalit AND ma.DEP_LINK_NEW = dsks.LINK_NEW)

DECLARE @cSource VARCHAR(10), @cSinth VARCHAR(10), @cAnalit VARCHAR(10), @iDEP_LINK_NEW INT
DECLARE CURS CURSOR SCROLL FOR SELECT DISTINCT cSource, cSinth, cAnalit
                               FROM @MISSED_ACCOUNTS
        OPEN CURS
        FETCH FIRST FROM CURS INTO @cSource, @cSinth, @cAnalit
        WHILE @@FETCH_STATUS=0
        BEGIN
            IF @@FETCH_STATUS=0
            BEGIN 
            	            	
            	declare @iFS_LINK INT, @iACC_LINK INT, @cBUFF_NAME VARCHAR(100)
            	SET @cBUFF_NAME = 'CONVERTER'
	            select top 1 @iFS_LINK = link from [{Variable_WorkDb}].dbo.FIN_SOURCE fs WHERE FS.CODE = @cSource
	            SELECT TOP 1 @iACC_LINK = LINK FROM [{Variable_WorkDb}].dbo.S_ACCOUNTS sa WHERE SA.cSinth = @cSinth AND sa.cAnalit = @cAnalit AND sa.LINK_DEP = {LINK_DEP_MAIN}
	            IF @iACC_LINK IS NOT NULL 
	            BEGIN 
	                exec [{Variable_WorkDb}].dbo.BufferClear @cBUFF_NAME
    	                
	                INSERT INTO [{Variable_WorkDb}].dbo.BUFFER([SID], ID, LINK)
	                SELECT SUSER_SID(),@cBUFF_NAME, @iACC_LINK	                

                    exec [{Variable_WorkDb}].dbo.[BK_PLAN_ACCOUNTS_ADDED_PART1] @strBUFFER_NAME = @cBUFF_NAME, @intLINK_FS = @iFS_LINK--, @iDEP_LINK = @iDEP_LINK_NEW
                END
                FETCH NEXT FROM CURS INTO @cSource, @cSinth, @cAnalit
            END
        END
        CLOSE CURS
        DEALLOCATE CURS
        
    DECLARE @iROWS_COUNT INT 
    SELECT @iROWS_COUNT = (SELECT DISTINCT COUNT(*) FROM @MISSED_ACCOUNTS)
    INSERT INTO [{Variable_TempDb}].dbo.[__Journal]
    VALUES (' ', '  : ' + convert(nvarchar(100),@iROWS_COUNT), '__JOUNRNAL_ACCOUNTS_ADDED', @iROWS_COUNT)
    
    IF not exists(select * from sysobjects where id = object_id('[dbo].[__JOUNRNAL_ACCOUNTS_ADDED]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
    CREATE TABLE [{Variable_TempDb}].dbo.__JOUNRNAL_ACCOUNTS_ADDED ( VARCHAR(100),  VARCHAR(254))
    
    INSERT INTO [{Variable_TempDb}].dbo.__JOUNRNAL_ACCOUNTS_ADDED
    SELECT ISNULL(ma.cSource,'') + '.' + ISNULL(ma.cSinth,'') + '.' + ISNULL(ma.cAnalit,''), LEFT(LTRIM(RTRIM(d.NAME)),254)
    FROM @MISSED_ACCOUNTS ma
    LEFT JOIN [{Variable_WorkDb}].dbo.DEPARTMENTS d ON d.LINK = ma.DEP_LINK_NEW

	--   
    UPDATE sa2
    SET
    sa2.ap_KBK      = sa1.ap_KBK,
    sa2.ap_EKR      = sa1.ap_EKR, 
    sa2.ap_DEP      = sa1.ap_DEP, 
    sa2.ap_SUB      = sa1.ap_SUB, 
    sa2.ap_EMP      = sa1.ap_EMP, 
    sa2.ap_NOMEN    = sa1.ap_NOMEN, 
    sa2.ap_INV      = sa1.ap_INV,
    sa2.ap_KAU      = sa1.ap_KAU, 
    sa2.ap_DEP_ACC  = sa1.ap_DEP_ACC, 
    sa2.ap_TMC      = sa1.ap_TMC, 
    sa2.ap_INDATE   = sa1.ap_INDATE, 
    sa2.ap_AP1      = sa1.ap_AP1, 
    sa2.ap_AP2      = sa1.ap_AP2,
    sa2.ap_AP3      = sa1.ap_AP3, 
    sa2.p_UZAB      = sa1.p_UZAB, 
    sa2.KBK_TYPE    = sa1.KBK_TYPE, 
    sa2.p_EKR       = sa1.p_EKR, 
    sa2.ANALIT_EKR  = CASE WHEN (sa1.ap_EKR <> 1 OR sa1.p_EKR = 0) THEN NULL ELSE
	                        CASE WHEN ekr2.LINK IS NOT NULL THEN ekr2.LINK ELSE sa2.ANALIT_EKR END
	                        END, 
    sa2.p_KASSA     = sa1.p_KASSA,
    sa2.p_DATE      = sa1.p_DATE, 
    sa2.B_YEAR0     = sa1.B_YEAR0, 
    sa2.OB_AP1      = sa1.OB_AP1, 
    sa2.OB_AP2      = sa1.OB_AP2, 
    sa2.OB_AP3      = sa1.OB_AP3, 
    sa2.NOMEN_TYPE  = sa1.NOMEN_TYPE,
    sa2.OB_DEP      = sa1.OB_DEP, 
    sa2.OB_DEP_ACC  = sa1.OB_DEP_ACC, 
    sa2.OB_EKR      = sa1.OB_EKR, 
    sa2.OB_EMP      = sa1.OB_EMP, 
    sa2.OB_INV      = sa1.OB_INV, 
    sa2.OB_KAU      = sa1.OB_KAU,
    sa2.OB_KBK      = sa1.OB_KBK, 
    sa2.OB_NOMEN    = sa1.OB_NOMEN, 
    sa2.OB_SUB      = sa1.OB_SUB, 
    sa2.OB_TMC      = sa1.OB_TMC
    FROM 
		{Variable_SmetaDb}.dbo.S_ACCOUNTS sa1
		INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 ON sa2.CODE = CASE WHEN sa1.ZABALANS = 1 AND ISNULL(sa1.cSource,'') = '' THEN '0.' + sa1.CODE ELSE sa1.CODE END AND SA2.LINK_DEP = {LINK_DEP_MAIN}
		LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU ekr ON ekr.LINK = sa1.ANALIT_EKR
		LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU ekr2 ON ekr2.CODE = ekr.CODE
	WHERE
		EXISTS (SELECT * FROM @MISSED_ACCOUNTS M WHERE M.cSource = SA1.cSource AND M.cSinth = SA1.cSinth AND M.cAnalit = SA1.cAnalit)	
        
COMMIT TRAN

