--      

UPDATE sa2
SET
	sa2.ap_KBK      = SIGN(sa2.ap_KBK + sa1.ap_KBK),
	SA2.CH_KBK		= CASE WHEN ISNULL(sa2.ap_KBK,0) = 0 AND ISNULL(sa1.ap_KBK,0) > 0 THEN 1 ELSE SA2.CH_KBK END,
	sa2.ap_EKR      = SIGN(sa2.ap_EKR + sa1.ap_EKR),
	SA2.CH_EKR		= CASE WHEN ISNULL(sa2.ap_EKR,0) = 0 AND ISNULL(sa1.ap_EKR,0) > 0 THEN 1 ELSE SA2.CH_EKR END,
	sa2.ap_DEP      = SIGN(sa2.ap_DEP + sa1.ap_DEP),
	SA2.CH_DEP		= CASE WHEN ISNULL(sa2.ap_DEP,0) = 0 AND ISNULL(sa1.ap_DEP,0) > 0 THEN 1 ELSE SA2.CH_DEP END,
	sa2.ap_SUB      = SIGN(sa2.ap_SUB + sa1.ap_SUB),
	SA2.CH_SUB		= CASE WHEN ISNULL(sa2.ap_SUB,0) = 0 AND ISNULL(sa1.ap_SUB,0) > 0 THEN 1 ELSE SA2.CH_SUB END,
	sa2.ap_EMP      = SIGN(sa2.ap_EMP + sa1.ap_EMP),
	SA2.CH_EMP		= CASE WHEN ISNULL(sa2.ap_EMP,0) = 0 AND ISNULL(sa1.ap_EMP,0) > 0 THEN 1 ELSE SA2.CH_EMP END,
	sa2.NOMEN_TYPE	= sa2.NOMEN_TYPE | sa1.NOMEN_TYPE,
	sa2.ap_NOMEN    = SIGN(sa2.ap_NOMEN + sa1.ap_NOMEN), 
	SA2.CH_NOMEN	= CASE WHEN ISNULL(sa2.ap_NOMEN,0) = 0 AND ISNULL(sa1.ap_NOMEN,0) > 0 THEN 1 ELSE SA2.CH_NOMEN END,
	sa2.ap_INV      = CASE WHEN sa2.ap_INV = 0 AND SIGN(sa2.ap_TMC + sa1.ap_TMC) = 1 THEN 0 ELSE SIGN(sa2.ap_INV + sa1.ap_INV) END,
	SA2.CH_INV 		= CASE WHEN ISNULL(sa2.ap_INV,0) = 0 AND ISNULL(sa1.ap_INV,0) > 0 THEN 1 ELSE SA2.CH_INV END,
	sa2.ap_KAU      = SIGN(sa2.ap_KAU + sa1.ap_KAU),
	SA2.CH_KAU 		= CASE WHEN ISNULL(sa2.ap_KAU,0) = 0 AND ISNULL(sa1.ap_KAU,0) > 0 THEN 1 ELSE SA2.CH_KAU END,
	sa2.ap_DEP_ACC  = SIGN(sa2.ap_DEP_ACC + sa1.ap_DEP_ACC),
	SA2.CH_DEP_ACC 	= CASE WHEN ISNULL(sa2.ap_DEP_ACC,0) = 0 AND ISNULL(sa1.ap_DEP_ACC,0) > 0 THEN 1 ELSE SA2.CH_DEP_ACC END,
	sa2.ap_TMC      = CASE WHEN sa2.ap_TMC = 0 AND SIGN(sa2.ap_INV + sa1.ap_INV) = 1 THEN 0 ELSE SIGN(sa2.ap_TMC + sa1.ap_TMC) END,
	SA2.CH_TMC 		= CASE WHEN ISNULL(sa2.ap_TMC,0) = 0 AND ISNULL(sa1.ap_TMC,0) > 0 THEN 1 ELSE SA2.CH_TMC END,
	sa2.ap_INDATE   = SIGN(sa2.ap_INDATE + sa1.ap_INDATE),
	SA2.CH_INDATE 	= CASE WHEN ISNULL(sa2.ap_INDATE,0) = 0 AND ISNULL(sa1.ap_INDATE,0) > 0 THEN 1 ELSE SA2.CH_INDATE END,
	sa2.ap_AP1      = SIGN(sa2.ap_AP1 + sa1.ap_AP1),
	SA2.CH_AP1		= CASE WHEN ISNULL(sa2.ap_AP1,0) = 0 AND ISNULL(sa1.ap_AP1,0) > 0 THEN 1 ELSE SA2.CH_AP1 END,
	sa2.ap_AP2      = SIGN(sa2.ap_AP2 + sa1.ap_AP2),
	SA2.CH_AP2		= CASE WHEN ISNULL(sa2.ap_AP2,0) = 0 AND ISNULL(sa1.ap_AP2,0) > 0 THEN 1 ELSE SA2.CH_AP2 END,
	sa2.ap_AP3      = SIGN(sa2.ap_AP3 + sa1.ap_AP3),
	SA2.CH_AP3  	= CASE WHEN ISNULL(sa2.ap_AP3,0) = 0 AND ISNULL(sa1.ap_AP3,0) > 0 THEN 1 ELSE SA2.CH_AP3 END
FROM 
	{Variable_SmetaDb}.dbo.S_ACCOUNTS sa1
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 
		ON sa2.CODE = CASE WHEN sa1.ZABALANS = 1 AND ISNULL(sa1.cSource {WORK_COLLATE},'') = '' THEN '0.' + sa1.CODE {WORK_COLLATE} ELSE sa1.CODE {WORK_COLLATE} END 
	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU ekr ON ekr.LINK = sa1.ANALIT_EKR
	LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU ekr2 ON ekr2.CODE = ekr.CODE {WORK_COLLATE}
WHERE
	SA2.LINK_DEP = {LINK_DEP_MAIN}
GO

UPDATE sa2
SET
	sa2.ap_TMC      = CASE WHEN sa2.ap_INV = 1 THEN 0 ELSE SIGN(sa2.ap_TMC + sa1.ap_TMC) END
FROM 
	{Variable_SmetaDb}.dbo.S_ACCOUNTS sa1
	INNER JOIN [{Variable_WorkDb}].dbo.S_ACCOUNTS sa2 
		ON sa2.CODE = CASE WHEN sa1.ZABALANS = 1 AND ISNULL(sa1.cSource {WORK_COLLATE},'') = '' THEN '0.' + sa1.CODE {WORK_COLLATE} ELSE sa1.CODE {WORK_COLLATE} END 
	LEFT JOIN {Variable_SmetaDb}.dbo.KOSGU ekr ON ekr.LINK = sa1.ANALIT_EKR
	LEFT JOIN [{Variable_WorkDb}].dbo.KOSGU ekr2 ON ekr2.CODE = ekr.CODE {WORK_COLLATE}
WHERE
	SA2.LINK_DEP = {LINK_DEP_MAIN}
GO
